apiVersion: tekton.dev/v1beta1
kind: PipelineRun
metadata:
  labels:
    opsperator.io/build-series: {{ bc_basename }}
  name: {{ bc_basename | lower }}-{{ bc_tag | default(bc_ref | default('master')) | lower }}-{{ bc_count | default(1) }}
  namespace: {{ namespace }}
spec:
  pipelineRef:
    name: {{ 'docker' if ((bc_type | default('Docker')) == 'Docker') else 'node-s2i' }}-build
  taskRunSpecs:
  - pipelineTaskName: build
    stepOverrides:
    #- name: generate-environ (if s2i build)
    #- name: generate-image-build-assets (if s2i+buildah build)
    #- name: patch-from (if docker build)
    #let's test with one override for now
    - name: build
      resources:
        limits:
          cpu: "{{ bc_cpu_limit | default('100m') }}"
          memory: "{{ bc_memory_limit | default('256Mi') }}"
        requests:
          cpu: "{{ bc_cpu_request | default('100m') }}"
          memory: "{{ bc_memory_request | default('256Mi') }}"
{% if tekton_preferred_builder in [ 'dslim', 'dind', 'buildah' ] %}
    #- name: push
{% endif %}
    #- name: digest-to-results
  params:
{% if bc_inbuild_clonepw | default(False) %}
  - name: clonepass
    value: "{{ bc_inbuild_clonepw }}"
{% endif %}
{% if bc_inbuild_cloneuser | default(False) %}
  - name: cloneuser
    value: "{{ bc_inbuild_cloneuser }}"
{% endif %}
{% if bc_dockerfile | default(False) %}
  - name: dockerfile
    value: {{ bc_dockerfile }}
{% endif %}
{% if bc_context | default(False) %}
  - name: dockerroot
    value: .{{ bc_context }}
{% endif %}
  - name: dstimage
    value: "{{ docker_registry }}/{{ namespace }}/{{ bc_toimage | default(bc_basename) }}:{{ bc_tag | default(bc_ref | default('master')) }}"
{% if bc_frombuilder | default(False) %}
  - name: frombuilder
{% if bc_frombuilder is regex('.') %}
    value: "{{ bc_frombuilder }}"
{% else %}
    value: {{ docker_registry }}/{{ namespace }}/{{ bc_frombuilder }}
{% endif %}
{% endif %}
{% if bc_fromimage | default(False) %}
  - name: fromimage
    value: "{{ bc_fromimage }}"
{% endif %}
  - name: git-ref
    value: "{{ bc_ref | default('master') }}"
  - name: git-repo-url
    value: "{{ bc_source }}"
{% if bc_versionval | default(False) and (bc_type | default('Docker')) == 'Docker' %}
  - name: versionarg
    value: "{{ bc_versionarg | default('VERSION') }}"
  - name: versionval
    value: "{{ bc_versionval }}"
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
  podTemplate:
    nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
      {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
  serviceAccountName: {{ pipeline_sa }}
{% if bc_timeout | default(False) %}
  timeout : {{ bc_timeout }}
{% endif %}
  workspaces:
  - name: git-repo
    volumeClaimTemplate:
      spec:
        accessModes:
        - ReadWriteOnce
        resources:
          requests:
            storage: "{{ bc_workspace_size | default('2Gi') }}"
{% if rwx_storage | default(False) %}
        storageClassName: "{{ rwx_storage }}"
{% elif rwo_storage | default(False) %}
        storageClassName: "{{ rwo_storage }}"
{% endif %}
{% if (sign_images_with | default('none')) in [ 'cosign', 'gpg' ] %}
  - name: sigsecret
    secret:
      secretName: {{ sign_images_with }}-{{ tekton_name }}
{% endif %}
